Package org.codehaus.groovy.transform

# Class TupleConstructorASTTransformation

java.lang.Object
org.codehaus.groovy.transform.AbstractASTTransformation
org.codehaus.groovy.transform.TupleConstructorASTTransformation

All Implemented Interfaces:
  `CompilationUnitAware`, `ASTTransformation`, `ErrorCollecting`, `TransformWithPriority`

public class TupleConstructorASTTransformation extends AbstractASTTransformation implements CompilationUnitAware, TransformWithPriority
Handles generation of code for the @TupleConstructor annotation.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final record`
  `TupleConstructorASTTransformation.SelectedTupleProperties`
  Result of `selectTupleProperties(org.codehaus.groovy.transform.AbstractASTTransformation, org.codehaus.groovy.ast.ClassNode, org.codehaus.groovy.ast.AnnotationNode)`: the super-class properties and self properties that pass the annotation's filters (includes / excludes / allNames / includeProperties / includeFields / includeSuperProperties / includeSuperFields / allProperties).

- ## Field Summary

  ### Fields inherited from class org.codehaus.groovy.transform.AbstractASTTransformation

  `RETENTION_CLASSNODE, sourceUnit`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `TupleConstructorASTTransformation()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static void`
  `addSpecialMapConstructors(int modifiers, ClassNode cNode, String message, boolean addNoArg)`
  `String`
  `getAnnotationName()`
  If the transform is associated with a single annotation, returns a name suitable for displaying in error messages.
  `int`
  `priority()`
  `static TupleConstructorASTTransformation.SelectedTupleProperties`
  `selectTupleProperties(AbstractASTTransformation xform, ClassNode cNode, AnnotationNode anno)`
  Resolves the property nodes the `@TupleConstructor` runtime transform would use as constructor parameters.
  `void`
  `setCompilationUnit(CompilationUnit unit)`
  Sets the compilation unit currently applying this transformation.
  `void`
  `visit(ASTNode[] nodes, SourceUnit source)`
  The method is invoked when an AST Transformation is active.

  ### Methods inherited from class org.codehaus.groovy.transform.AbstractASTTransformation

  `addError, checkIncludeExcludeUndefinedAware, checkIncludeExcludeUndefinedAware, checkNotInterface, checkPropertyList, checkPropertyList, checkPropertyList, copyAnnotatedNodeAnnotations, copyAnnotatedNodeAnnotations, deemedInternal, deemedInternalName, getMemberClassList, getMemberClassValue, getMemberClassValue, getMemberIntValue, getMemberStringList, getMemberStringValue, getMemberStringValue, getMemberValue, hasAnnotation, init, markAsInternal, memberHasValue, shouldSkip, shouldSkip, shouldSkip, shouldSkipOnDescriptorUndefinedAware, shouldSkipUndefinedAware, shouldSkipUndefinedAware, shouldSkipUndefinedAware, tokenize`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### TupleConstructorASTTransformation

    public TupleConstructorASTTransformation()

- ## Method Details

  - ### priority

    public int priority()
    Specified by:
      `priority` in interface `TransformWithPriority`

  - ### getAnnotationName

    public String getAnnotationName()
    Description copied from class: `AbstractASTTransformation`
    If the transform is associated with a single annotation, returns a name suitable for displaying in error messages.
    Overrides:
      `getAnnotationName` in class `AbstractASTTransformation`
    Returns:
      The simple name of the annotation including the "@" or null if no such name is defined

  - ### setCompilationUnit

    public void setCompilationUnit(CompilationUnit unit)
    Description copied from interface: `CompilationUnitAware`
    Sets the compilation unit currently applying this transformation.
    Specified by:
      `setCompilationUnit` in interface `CompilationUnitAware`
    Parameters:
      `unit` - the active compilation unit

  - ### visit

    public void visit(ASTNode[] nodes, SourceUnit source)
    Description copied from interface: `ASTTransformation`
    The method is invoked when an AST Transformation is active. For local transformations, it is invoked once each time the local annotation is encountered. For global transformations, it is invoked once for every source unit, which is typically a source file.
    Specified by:
      `visit` in interface `ASTTransformation`
    Parameters:
      `nodes` - The ASTnodes when the call was triggered. Element 0 is the AnnotationNode that triggered this annotation to be activated. Element 1 is the AnnotatedNode decorated, such as a MethodNode or ClassNode. For global transformations it is usually safe to ignore this parameter.
      `source` - The source unit being compiled. The source unit may contain several classes. For global transformations, information about the AST can be retrieved from this object.

  - ### selectTupleProperties

    public static TupleConstructorASTTransformation.SelectedTupleProperties selectTupleProperties(AbstractASTTransformation xform, ClassNode cNode, AnnotationNode anno)
    Resolves the property nodes the `@TupleConstructor` runtime transform would use as constructor parameters. Honours `includes`, `excludes`, `allNames`, `includeProperties`, `includeFields`, `includeSuperProperties`, `includeSuperFields`, and `allProperties` attributes the same way the full transform does so the joint-compilation stubber stays in lockstep.
    Since:
      6.0.0

  - ### addSpecialMapConstructors

    public static void addSpecialMapConstructors(int modifiers, ClassNode cNode, String message, boolean addNoArg)